
--------------------------------------------------------

local model3D_potion = nil
local model3D_spike = nil
local model3D_treasure = nil
local model3D_baddy1 = nil
local model3D_baddy2 = nil
local sphere3D_projectile = nil

local countbar_money = nil
local countbar_lifes = nil
local countbar_keys = nil

local sound_potion = nil
local sound_chest = nil
local sound_hit = nil

local is_editor_mode = true

--------------------------------------------------------

Spike = {
	load = function()
		This.setVariable("bool:isHit", false)
		--This.setVariable("ptr:model", model3D_spike)
	end,
	manage = function(pos)
		if Player.distanceTo(pos) < 10.0 then
			if not This.getVariable("bool:isHit") then
				This.setVariable("bool:isHit", true)
				sound_hit:play()
				countbar_lifes:setValue(countbar_lifes:getValue()-1)
			end
		else
			This.setVariable("bool:isHit", false)
		end
	end,
	draw3D = function(pos)
		--local model3Dtmp = This.getVariable("ptr:model")
		model3D_spike:position(pos)
		model3D_spike:draw()
	end,
	unload = function()
	end
}

--------------------------------------------------------

Potion = {
	load = function()
		This.setVariable("bool:isOpened", false);
	end,
	manage = function(pos)
		if Player.distanceTo(pos) < 10.0 and not This.getVariable("bool:isOpened") then
			This.setVariable("bool:isOpened", true)
			sound_potion:play()
			countbar_lifes:setValue(countbar_lifes:getValue()+1)
		end
	end,
	draw3D = function(pos)
		if This.getVariable("bool:isOpened") then
			model3D_potion:setAnimationFrame(1)
		else
			model3D_potion:setAnimationFrame(0)
		end
		model3D_potion:position(pos)
		model3D_potion:draw()
	end,
	unload = function()
	end
}

--------------------------------------------------------

Treasure = {
	load = function()
		This.setVariable("bool:isOpened", false);
	end,
	manage = function(pos)
		if not Player.isGameOver() then
			if Player.distanceTo(pos) < 10.0 and not This.getVariable("bool:isOpened") then
				This.setVariable("bool:isOpened", true)
				sound_chest:play()
				countbar_money:setValue(countbar_money:getValue()+1)
			end
		end
	end,
	draw3D = function(pos)
		if This.getVariable("bool:isOpened") then
			model3D_treasure:setAnimationFrame(1)
		else
			model3D_treasure:setAnimationFrame(0)
		end
		model3D_treasure:position(pos)
		model3D_treasure:draw()
	end,
	unload = function()
	end
}

--------------------------------------------------------

function Baddy1_manageRelativePos()
	local relative_pos = This.getVariable("number:relative_pos")
	
	if This.getVariable("bool:reverse") then
		relative_pos = relative_pos - Misc.getFrameDuration() * 0.05
	else
		relative_pos = relative_pos + Misc.getFrameDuration() * 0.05
	end
	
	if relative_pos > 60.0 then
		relative_pos = 60.0
		This.setVariable("bool:reverse", true)
	elseif relative_pos < 0.0 then
		relative_pos = 0.0
		This.setVariable("bool:reverse", false)
	end
	
	This.setVariable("number:relative_pos", relative_pos)
end

Baddy1AxisX = {

	load = function()
		This.setVariable("bool:reverse", false)
		This.setVariable("number:relative_pos", 0.0)
		This.setVariable("int:hitNextTime", 0)
	end,
	
	manage = function(pos)
		if not is_editor_mode then
			Baddy1_manageRelativePos()
			if (Player.distanceTo(Number3.new(pos:x()+This.getVariable("number:relative_pos"),pos:y(),pos:z())) < 10.0) 
				and (This.getVariable("int:hitNextTime") < Misc.getTime()) then
				This.setVariable("int:hitNextTime", Misc.getTime()+1000)
				sound_hit:play()
				countbar_lifes:setValue(countbar_lifes:getValue()-1)
			end
		end
	end,
	
	draw3D = function(pos)
		model3D_baddy1:position(Number3.new(pos:x()+This.getVariable("number:relative_pos"),pos:y(),pos:z()))--, 0, 90, 0)
		model3D_baddy1:draw()
	end,
	
	unload = function()
	end
}

Baddy1AxisZ = {

	load = function()
		This.setVariable("bool:reverse", false)
		This.setVariable("number:relative_pos", 0.0)
		This.setVariable("int:hitNextTime", 0)
	end,
	
	manage = function(pos)
		if not is_editor_mode then
			Baddy1_manageRelativePos()
			if (Player.distanceTo(Number3.new(pos:x(),pos:y(),pos:z()+This.getVariable("number:relative_pos"))) < 10.0) 
				and (This.getVariable("int:hitNextTime") < Misc.getTime()) then
				This.setVariable("int:hitNextTime", Misc.getTime()+1000)
				sound_hit:play()
				countbar_lifes:setValue(countbar_lifes:getValue()-1)
			end
		end
	end,
	
	draw3D = function(pos)
		model3D_baddy1:position(Number3.new(pos:x(),pos:y(),pos:z()+This.getVariable("number:relative_pos")))
		model3D_baddy1:draw()
	end,
	
	unload = function()
	end
}

--------------------------------------------------------

function Baddy2_reset(baddyPos)
	local playerPos = Player.position()
	local normalizedPos = Maths.getNormalizedVector(playerPos, baddyPos)
	This.setVariable("pos:mvtVector", normalizedPos)
	This.setVariable("pos:projectilePosition", baddyPos)
end

Baddy2 = {

	load = function()
		Baddy2_reset(This.position())
	end,
	
	manage = function(baddyPos)
		
		if not is_editor_mode then
			
			local projectilePos = This.getVariable("pos:projectilePosition")
			
			if CubesEngine.get():isPositionColliding(projectilePos) or This.distanceTo(projectilePos) > 200.0 
				or Player.distanceTo(projectilePos) < 10.0 then
				if Player.distanceTo(projectilePos) < 10.0 then
					sound_hit:play()
					countbar_lifes:setValue(countbar_lifes:getValue()-1)
				end
				Baddy2_reset(baddyPos)
				projectilePos = This.getVariable("pos:projectilePosition")
			end
				
			local mvtVector = This.getVariable("pos:mvtVector")
			projectilePos = projectilePos + mvtVector * Misc.getFrameDuration() * 0.05
			This.setVariable("pos:projectilePosition", projectilePos)
		end
	end,
	
	draw3D = function(baddyPos)
		--model3D_baddy2:position(x,y,z, 90, 0, 0)
		model3D_baddy2:position(baddyPos)
		model3D_baddy2:draw()
		sphere3D_projectile:position(This.getVariable("pos:projectilePosition"))
		sphere3D_projectile:draw()
	end,
	
	unload = function()
	end
}

--------------------------------------------------------

ActiveObjectsMgr = {}

function ActiveObjectsMgr.init()

	sound_potion = Sound.new("data/sound/41529__jamius__potiondrinklong.wav")
	sound_chest = Sound.new("data/sound/202092__spookymodem__chest-opening.wav")
	sound_hit = Sound.new("data/sound/203976__thatbennyguy__female-hurt__mod.wav")

	model3D_potion = Model3D.new('data/obj_potion/potion.obj', 'data/obj_potion/potion_empty.obj')
	model3D_potion:scaleKeepProportions(20.0)
	model3D_potion:runAnimation(false)
	
	model3D_spike = Model3D.new('data/obj_spike/spike.obj')
	model3D_spike:scaleKeepProportions(0.14)
	
	model3D_treasure = Model3D.new('data/obj_chest/chest.obj', 'data/obj_chest/chest_opened.obj')
	model3D_treasure:scaleKeepProportions(0.5)
	model3D_treasure:runAnimation(false)
	
	model3D_baddy1 = Model3D.new(
		'data/obj_player_robot/player_frame1.obj',
		'data/obj_player_robot/player_frame2.obj',
		'data/obj_player_robot/player_frame3.obj',
		'data/obj_player_robot/player_frame4.obj',
		'data/obj_player_robot/player_frame5.obj')
	model3D_baddy1:scaleKeepProportions(0.5)
	model3D_baddy1:runAnimation(false)
	
	model3D_baddy2 = Model3D.new('data/obj_baddy2/baddy2.obj')
	model3D_baddy2:scaleKeepProportions(0.5)
	
	sphere3D_projectile = Sphere3D.new('data/obj_baddy2/projectile.png')
	sphere3D_projectile:radius(2.5)
	
	countbar_money = CountBar.new("data/counters/money.png", 0, Int2.new(250, 20), 35)
	countbar_lifes = CountBar.new("data/counters/heart.png", 3, Int2.new(250, 80), 35)
	countbar_keys = CountBar.new("data/counters/key.png", 0, Int2.new(250, 140), 35)

	local activeObjects = ActiveObjects.get()
	activeObjects:addType("Potion", "data/active_objects_insight/0.png")
	activeObjects:addType("Spike", "data/active_objects_insight/1.png")
	activeObjects:addType("Treasure", "data/active_objects_insight/2.png")
	activeObjects:addType("Baddy1AxisX", "data/active_objects_insight/3.png")
	activeObjects:addType("Baddy1AxisZ", "data/active_objects_insight/4.png")
	activeObjects:addType("Baddy2", "data/active_objects_insight/5.png")
end

--------------------------------------------------------

function ActiveObjectsMgr.manage(is_editor_mode_)
	is_editor_mode = is_editor_mode_
	ActiveObjects.get():manage()
end

--------------------------------------------------------

function ActiveObjectsMgr.draw3D()
	ActiveObjects.get():draw3D(is_editor_mode)
end

--------------------------------------------------------

function ActiveObjectsMgr.draw2D()
	if countbar_lifes:getValue() <= 0 then
		Player.setGameOver(true)
		ActiveObjects.get():resetActiveObjects()
	end
	countbar_money:draw()
	countbar_lifes:draw()
	countbar_keys:draw()
end

--------------------------------------------------------

function ActiveObjectsMgr.reset()
	countbar_lifes:setValue(3)
	countbar_money:setValue(0)
	countbar_keys:setValue(0)
	ActiveObjects.get():resetActiveObjects()
end

function ActiveObjectsMgr.nbKeys(newvalue)
	if newvalue ~= nil then
		countbar_keys:setValue(newvalue)
	end
	return countbar_keys:getValue()
end

function ActiveObjectsMgr.loseOneLife()
	countbar_lifes:setValue(countbar_lifes:getValue()-1)
	sound_hit:play()
end

--------------------------------------------------------

function ActiveObjectsMgr.drop()
	model3D_potion:drop()
	model3D_spike:drop()
	model3D_treasure:drop()
	model3D_baddy1:drop()
	model3D_baddy2:drop()
	sphere3D_projectile:drop()
	sound_potion:drop()
	sound_chest:drop()
	sound_hit:drop()
	
	countbar_money:drop()
	countbar_lifes:drop()
	countbar_keys:drop()
	ActiveObjects.get():clearTypes()
end

--------------------------------------------------------
