
LoadSaveMenu = {}

local is_opened = false
local buttons = {}

local BORDER_LEFT = 20+100+20

local PSTART = Int2.new(30, 40)

local BACKGROUND_COLOR = Color.new(0,0,0,170)

local function loadWorld_(filepath_world)
	Misc.drawPleaseWait()
	if filepath_world == nil then
		CubesAndActiveObjects.clearAllWorld()
	else
		CubesAndActiveObjects.loadWorldInAppFolder(filepath_world)
	end
	--is_opened = false
	Player.position(Editor.getInitialPositionPlayer())
end

function LoadSaveMenu.init()
	buttons[1] = Button.new("data/load_save_menu/default_world1.png", "")
	buttons[2] = Button.new("data/load_save_menu/default_world2.png", "")
	buttons[3] = Button.new("data/load_save_menu/empty_world.png", "")
	buttons[4] = Button.new("data/load_save_menu/quit_game.png", "")
	
	for i = 1,9 do
		buttons[10+i] = Button.new('data/load_save_menu/load.png', '')
	end
	for i = 1,9 do
		buttons[20+i] = Button.new('data/load_save_menu/save.png', '')
	end
	
	for key, button in pairs(buttons) do
		button:colorMouseOver(Color.new(0,0,0,128))
	end
end

function LoadSaveMenu.openOrClose()
	is_opened = not is_opened
end

function LoadSaveMenu.close()
	is_opened = false
end

function LoadSaveMenu.draw()

	if is_opened then
		Scene2D.drawRectangle(Int2.new(PSTART:x()-20, PSTART:y()-20), Int2.new(Misc.getWindowSize():width()-(20+100+20)-20, Misc.getWindowSize():height()-150), BACKGROUND_COLOR)
		
		local hbut = Misc.getWindowSize():height()-40
		local w_bu = buttons[1]:width()
		local wi_bu = w_bu+20
		
		--Scene2D.drawText("Load a preset world", Int2.new(PSTART:x(), PSTART:y()+10), 20)
		buttons[1]:draw(Int2.new(PSTART:x(),PSTART:y()))
		buttons[2]:draw(Int2.new(PSTART:x()+wi_bu,PSTART:y()))
		buttons[3]:draw(Int2.new(PSTART:x()+wi_bu*2,PSTART:y()))
		if Misc.getRunningEnvironment() ~= 'ENVIRONMENT_WINDOWS_STORE' 
			and Misc.getRunningEnvironment() ~= 'ENVIRONMENT_WINDOWS_STORE_WITH_ADS' then
			buttons[4]:draw(Int2.new(PSTART:x()+wi_bu*4,PSTART:y()))
		end
		--Scene2D.drawText("Load a world from a slot", Int2.new(PSTART:x(), PSTART:y()+250), 20)
		--Scene2D.drawText("Save a world into a slot", Int2.new(PSTART:x(), PSTART:y()+450), 20)
		w_bu = buttons[11]:width()
		local h_bu = 100
		wi_bu = w_bu+14
		for j = 0, 1, 1 do
			for i = 1, 9, 1 do
				if j==1 or FileUtil.fileExistsInAppData('slot'..i..'.3dworld') then
					buttons[10+j*10+i]:draw(Int2.new(PSTART:x()+(i-1)*wi_bu, PSTART:y()+300+j*200))
					Scene2D.drawText(""..i, buttons[10+j*10+i]:position()+Int2.new(20, 5), 30.0)
				end
			end
		end
		
		--Scene2D.drawText("To backup or share your slots with your friends, go to the following directory:\n"
		--	..FileUtil.getAppDataFullPath().."\n"
		--	.."and copy the files with the .3dworld extension to anywhere you want (for example to an USB key).\n", 
		--	PSTART + Int2.new(0, 650),15)
		
	end
end

function LoadSaveMenu.onMousePressed(mouse_button, mouse_pos, is_double_click)
	if is_opened then
		if buttons[1]:isIn(mouse_pos) then
			loadWorld_('data/init_world1.3dworld')
		elseif buttons[2]:isIn(mouse_pos) then
			loadWorld_('data/init_world2.3dworld')
		elseif buttons[3]:isIn(mouse_pos) then
			loadWorld_(nil)
			CubesEngine.get():makeCuboid(Int3.new(-5,-2,-5),Int3.new(5,2,5), 1)
		elseif buttons[4]:isIn(mouse_pos) then
			if Misc.getRunningEnvironment() ~= 'ENVIRONMENT_WINDOWS_STORE' 
				and Misc.getRunningEnvironment() ~= 'ENVIRONMENT_WINDOWS_STORE_WITH_ADS' then
				Misc.quitApplication()
			end
		
		else
			local w_bu = 60
			local h_bu = 100
			local wi_bu = w_bu+14
			
			for j = 0, 1, 1 do
				for i = 1, 9, 1 do
					if buttons[10+j*10+i]:isIn(mouse_pos) then
						if j == 0 then
							if FileUtil.fileExistsInAppData('slot'..i..'.3dworld') then
								Misc.drawPleaseWait()
								CubesAndActiveObjects.loadWorldInAppData('slot'..i..'.3dworld')
								Player.position(Editor.getInitialPositionPlayer())
								--is_opened = false
							end
						else
							Misc.drawPleaseWait()
							CubesAndActiveObjects.saveWorldInAppData('slot'..i..'.3dworld')
							--is_opened = false
						end
					end
				end
			end
		end
	end
	return false
end

function LoadSaveMenu.onMouseMoved(mouse_button, mouse_pos, is_double_click)
	if is_opened then 
		for key, button in pairs(buttons) do
			button:checkIsOver(mouse_pos)
		end
	end
end

function LoadSaveMenu.drop()
	for key, button in pairs(buttons) do
		button:drop()
	end
end
