
OptionsMenu = {}

local is_opened = false
local buttons = {}

local PSTART = Int2.new(30, 40)

local BORDER_LEFT = 20+100+20

local BACKGROUND_COLOR = Color.new(0,0,0,170)
local COLOR_BORDER_ICON = Color.new(255,255,255,255)

function OptionsMenu.init()
	buttons['fog_far'] = Button.new('data/options_menu/fog_far.png', '')
	buttons['fog_near'] = Button.new('data/options_menu/fog_near.png', '')
	buttons['undetailed_mode'] = Button.new('data/options_menu/undetailed_mode.png', '')
	buttons['undetailed_mode']:setBorder(COLOR_BORDER_ICON, 5)
	buttons['detailed_mode'] = Button.new('data/options_menu/detailed_mode.png', '')
	
	for key, button in pairs(buttons) do
		button:colorMouseOver(Color.new(0,0,0,128))
	end
end

function OptionsMenu.draw()

	if is_opened then
		Scene2D.drawRectangle(Int2.new(PSTART:x()-20, PSTART:y()-20), Int2.new(Misc.getWindowSize():width()-(20+100+20)-20, Misc.getWindowSize():height()-150), BACKGROUND_COLOR)
		buttons['fog_far']:draw(PSTART)
		buttons['fog_near']:draw(Int2.new(PSTART:x()+buttons['fog_far']:width() + 40,PSTART:y()))
		buttons['undetailed_mode']:draw(Int2.new(PSTART:x(),PSTART:y()+buttons['fog_far']:height()+40))
		buttons['detailed_mode']:draw(Int2.new(PSTART:x()+buttons['fog_far']:width() + 40,PSTART:y()+buttons['fog_far']:height()+40))
	end
end

function OptionsMenu.openOrClose()
	is_opened = not is_opened
end

function OptionsMenu.close()
	is_opened = false
end

function OptionsMenu.onMousePressed(mouse_button, mouse_pos, is_double_click, cubes_engine)
	if is_opened then
		if buttons['fog_far']:isIn(mouse_pos) then
			Scene3D.fogDistance(Scene3D.fogDistance()+100)
			return true
		elseif buttons['fog_near']:isIn(mouse_pos) then
			Scene3D.fogDistance(Scene3D.fogDistance()-100)
			return true
		elseif buttons['undetailed_mode']:isIn(mouse_pos) then
			local is_detailed, lod = cubes_engine:detailedMode()
			cubes_engine:detailedMode(false, lod)
			buttons['detailed_mode']:setBorder(COLOR_BORDER_ICON, 0)
			buttons['undetailed_mode']:setBorder(COLOR_BORDER_ICON, 5)
			return true
 		elseif buttons['detailed_mode']:isIn(mouse_pos) then
			local is_detailed, lod = cubes_engine:detailedMode()
			cubes_engine:detailedMode(true, lod)
			buttons['detailed_mode']:setBorder(COLOR_BORDER_ICON, 5)
			buttons['undetailed_mode']:setBorder(COLOR_BORDER_ICON, 0)
			return true
		end
	end
	return false
end

function OptionsMenu.onMouseMoved(mouse_button, mouse_pos, is_double_click)
	for key, button in pairs(buttons) do
		button:checkIsOver(mouse_pos)
	end
end

function OptionsMenu.drop()
	for key, button in pairs(buttons) do
		button:drop()
	end
end
