uniform mat4x4 cameraMatrix;
uniform float fogStart;
uniform float fogEnd;
uniform vec3 data;
uniform vec4 fogColor;
uniform int usesLight;
uniform int userDefinedTextureId;
uniform sampler2D colorMap;

varying vec3 vertexToFogReferencePos;
varying float lightMagnitude;

void main(void)
{
	vec2 cPos;
	
	vec4 vertexPos4 = gl_ModelViewMatrix * gl_Vertex;
    vertexToFogReferencePos = vec3(vertexPos4.x, vertexPos4.y, vertexPos4.z);

    vec3 normal = normalize(gl_NormalMatrix * vec3(gl_Normal.x, gl_Normal.y, gl_Normal.z));
	vec4 normalWorldCoord = vec4(normal.x, normal.y, normal.z, 0.0) * cameraMatrix;
	normal = normalize(normalWorldCoord.xyz);
	
	vec3 lightDirection = normalize(vec3(-0.7, -1.0, -0.5));// direction of the sun
	lightMagnitude = 0.45 + clamp(dot(normal, -lightDirection), 0.0, 1.0) * 0.55;
	
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	
	gl_TexCoord[0] = gl_MultiTexCoord0;

	if (1)//userDefinedTextureId>0)
	{
		if (1)
		{
			vec4 tmpPos2 = gl_ModelViewMatrix * gl_Vertex;
			vec4 tmpPos = inverse(cameraMatrix) * gl_ModelViewMatrix * gl_Vertex;
			float time_dur = data.x;
			//time_dur=0.0;
			vec4 displacedVertex;
				displacedVertex.x = tmpPos.x + 30*cos(tmpPos2.x/100+time_dur/1000) + 30*sin(tmpPos2.y/100+time_dur/1000);// + 3.0*cos( gl_Vertex.x/100+time_dur/100 );
				//displacedVertex.y = tmpPos.y + 3.0*exp( abs(gl_Vertex.x)/600) + 3.0*exp( (abs(gl_Vertex.z)+sin(time_dur/100)*100)/600 );
				displacedVertex.y = tmpPos.y + 30*cos(tmpPos2.y/100+time_dur/1000) + 30*sin(tmpPos2.z/100+time_dur/1000);
				displacedVertex.z = tmpPos.z + 30*cos(tmpPos2.z/100+time_dur/1000) + 30*sin(tmpPos2.x/100+time_dur/1000);/*
				
				// vec3 cam_pos = -transpose(mat3(gl_ModelViewMatrix)) * gl_ModelViewMatrix[3].xyz;
				
				vec4 posTmp = gl_ModelViewMatrix * gl_Vertex;
	
				//displacedVertex.x = gl_Vertex.x*2/3 + sin(gl_Vertex.x-cam_pos.x)*1/3;//60*sin(posTmp.x/100.0-gl_Vertex.x/100.0);
				//displacedVertex.y = gl_Vertex.y*2/3 + sin(gl_Vertex.y-cam_pos.y)*1/3;//60*sin(posTmp.y/100.0-gl_Vertex.y/100.0);
				//displacedVertex.z = gl_Vertex.z*2/3 + sin(gl_Vertex.z-cam_pos.z)*1/3;// 60*sin(posTmp.z/100.0-gl_Vertex.z/100.0);
				
			//displacedVertex.x = gl_Vertex.x;// + 3.0*sin( gl_Vertex.x/10);
			//displacedVertex.y = gl_Vertex.y + 3.0*cos( gl_Vertex.x*5+time_dur/1000) + 3.0*sin( gl_Vertex.z*5+time_dur/1000);
			//displacedVertex.z = gl_Vertex.z;// + 3.0*sin( gl_Vertex.z/10);
			//displacedVertex.w = 1.0;
			//displacedVertex.x = (5000+gl_Vertex.y/10) * sin( (8000+gl_Vertex.x)/4000) * cos( (8000+gl_Vertex.z)/4000);
			//displacedVertex.y = (5000+gl_Vertex.y/10) * sin( (8000+gl_Vertex.x)/4000) * sin( (8000+gl_Vertex.z)/4000);
			//displacedVertex.z = (5000+gl_Vertex.y/10) * cos( (8000+gl_Vertex.x)/4000);// + 3.0*sin( gl_Vertex.z/10);
			displacedVertex.w = 1.0;
			
			*/
			displacedVertex.w = 1.0;
			gl_Position = gl_ProjectionMatrix * cameraMatrix * displacedVertex;
		}
		else if (userDefinedTextureId==2)
		{
			float time_dur = data.x;
			vec2 cPos = -1.0 + 2.0 * gl_TexCoord[0].xy / vec2(10.0,10.0);
			float cLength = length(cPos);
			gl_TexCoord[0].xy = gl_TexCoord[0].xy + (cPos/cLength)*cos(cLength*12.0-time_dur*0.005)*0.03;
			gl_Position.y = gl_Position.y + 1.0*cos( gl_Vertex.x*1000+time_dur/100 ) + 1.0*sin( gl_Vertex.z*1000+time_dur/100 );
		}
		else if (userDefinedTextureId==3)
		{
			float time_dur = data.x;
			gl_Position.y = gl_Position.y + 0.5*sin( gl_Vertex.y+time_dur/75 );
		}
		else if (userDefinedTextureId==4)
		{
			vec4 tmpPos = inverse(cameraMatrix) * gl_ModelViewMatrix * gl_Vertex;
			float time_dur = data.x;
			//time_dur=0.0;
			vec4 displacedVertex;
			displacedVertex.x = tmpPos.x + 0.3*sin(tmpPos.x*10+time_dur/1000);
			displacedVertex.y = tmpPos.y + 0.3*sin(tmpPos.y*10+time_dur/1000);
			displacedVertex.z = tmpPos.z + 0.3*sin(tmpPos.z*10+time_dur/1000);
			displacedVertex.w = 1.0;
			gl_Position = gl_ProjectionMatrix * cameraMatrix * displacedVertex;
		}
	}

	gl_FrontColor = gl_Color;
	
	// float time_dur = data.x;
	// gl_FrontColor.r *= abs(cos(gl_Vertex.x/100+time_dur/1000) + sin(gl_Vertex.z/100+time_dur/1000));
	// gl_FrontColor.g *= abs(cos(gl_Vertex.x/100+time_dur/1000) + sin(gl_Vertex.z/100+time_dur/1000));
	// gl_FrontColor.b *= abs(cos(gl_Vertex.x/100+time_dur/1000) + sin(gl_Vertex.z/100+time_dur/1000));
}
